#!/usr/bin/env python
# -*- coding:utf-8 -*-

# http://www.accesstoinsight.org/tipitaka/index.html
PaliTextTitle = {
'Tipiṭaka (Mūla)': 'Pāḷi Canon',
'Vinayapiṭaka': 'The Basket of the Discipline',
'Suttapiṭaka': 'The Basket of Discourses',
  'Dīghanikāya': 'Long Discourses',
  'Dīgha nikāya': 'Long Discourses',
    'Sīlakkhandhavaggapāḷi':'The Division Concerning Morality',
      'Brahmajālasuttaṃ': 'The All-embracing Net of Views',
      'Sāmaññaphalasuttaṃ': 'The Fruits of the Contemplative Life',
#     'Ambaṭṭhasuttaṃ': '',
#     'Soṇadaṇḍasuttaṃ': '',
#     'Kūṭadantasuttaṃ': '',
#     'Mahālisuttaṃ': '',
#     'Jāliyasuttaṃ': '',
#     'Mahāsīhanādasuttaṃ': '',
      'Poṭṭhapādasuttaṃ': 'About Poṭṭhapāda',
#     'Subhasuttaṃ': '',
      'Kevaṭṭasuttaṃ': 'To Kevaṭṭa',
      'Lohiccasuttaṃ': 'To Lohicca',
#     'Tevijjasuttaṃ': '',
    'Mahāvaggapāḷi':'The Large Division',
#     'Mahāpadānasuttaṃ': '',
      'Mahānidānasuttaṃ': 'The Great Causes Discourse',
      'Mahāparinibbānasuttaṃ': 'Last Days of the Buddha/The Great Discourse on the Total Unbinding',
#     'Mahāsudassanasuttaṃ': '',
#     'Janavasabhasuttaṃ': '',
#     'Mahāgovindasuttaṃ': '',
      'Mahāsamayasuttaṃ': 'The Great Assembly/The Great Meeting',
      'Sakkapañhasuttaṃ': "Sakka's Questions",
      'Mahāsatipaṭṭhānasuttaṃ': 'The Great Frames of Reference',
#     'Pāyāsisuttaṃ': '',
    'Pāthikavaggapāḷi':'The Pāthika Division',
#     'Pāthikasuttaṃ': '',
#     'Udumbarikasuttaṃ': '',
      'Cakkavattisuttaṃ': 'The Wheel-turning Emperor',
#     'Aggaññasuttaṃ': '',
#     'Sampasādanīyasuttaṃ': '',
#     'Pāsādikasuttaṃ': '',
#     'Lakkhaṇasuttaṃ': '',
      'Siṅgālasuttaṃ': "The Buddha's Advice to Sigalaka/The Discourse to Sigala",
      'Āṭānāṭiyasuttaṃ': 'Discourse on Āṭānāṭiya',
#     'Saṅgītisuttaṃ': '',
#     'Dasuttarasuttaṃ': '',
  'Majjhimanikāya': 'Middle-length Discourses',
  'Saṃyuttanikāya': 'Grouped" Discourses',
    'Sagāthāvaggapāḷi': 'The Section of Verses',
#     'Devatāsaṃyuttaṃ': '',
#     'Devaputtasaṃyuttaṃ': '',
#     'Kosalasaṃyuttaṃ': '',
#     'Mārasaṃyuttaṃ': '',
#     'Bhikkhunīsaṃyuttaṃ': '',
#     'Brahmasaṃyuttaṃ': '',
#     'Brāhmaṇasaṃyuttaṃ': '',
#     'Vaṅgīsasaṃyuttaṃ': '',
#     'Vanasaṃyuttaṃ': '',
#     'Yakkhasaṃyuttaṃ': '',
#     'Sakkasaṃyuttaṃ': '',
    'Nidānavaggapāḷi': 'The Section on Causation',
#     'Nidānasaṃyuttaṃ': '',
#     'Abhisamayasaṃyuttaṃ': '',
#     'Dhātusaṃyuttaṃ': '',
#     'Anamataggasaṃyuttaṃ': '',
#     'Kassapasaṃyuttaṃ': '',
#     'Lābhasakkārasaṃyuttaṃ': '',
#     'Rāhulasaṃyuttaṃ': '',
#     'Lakkhaṇasaṃyuttaṃ': '',
#     'Opammasaṃyuttaṃ': '',
#     'Bhikkhusaṃyuttaṃ': '',
    'Khandhavaggapāḷi': 'The Section on the Aggregates',
#     'Khandhasaṃyuttaṃ': '',
#     'Rādhasaṃyuttaṃ': '',
#     'Diṭṭhisaṃyuttaṃ': '',
#     'Okkantasaṃyuttaṃ': '',
#     'Uppādasaṃyuttaṃ': '',
#     'Kilesasaṃyuttaṃ': '',
#     'Sāriputtasaṃyuttaṃ': '',
#     'Nāgasaṃyuttaṃ': '',
#     'Supaṇṇasaṃyuttaṃ': '',
#     'Gandhabbakāyasaṃyuttaṃ': '',
#     'Valāhakasaṃyuttaṃ': '',
#     'Vacchagottasaṃyuttaṃ': '',
#     'Jhānasaṃyuttaṃ': '',
    'Saḷāyatanavaggapāḷi': 'The Section on the Six Sense Bases',
#     'Saḷāyatanasaṃyuttaṃ': '六處相應',
#     'Vedanāsaṃyuttaṃ': '受相應',
#     'Mātugāmasaṃyuttaṃ': '女人相應',
#     'Jambukhādakasaṃyuttaṃ': '閻浮車相應',
#     'Sāmaṇḍakasaṃyuttaṃ': '沙門出家相應',
#     'Moggallānasaṃyuttaṃ': '目犍連相應',
#     'Cittasaṃyuttaṃ': '質多相應',
#     'Gāmaṇisaṃyuttaṃ': '聚落主相應',
#     'Asaṅkhatasaṃyuttaṃ': '無為相應',
#     'Abyākatasaṃyuttaṃ': '無記相應',
    'Mahāvaggapāḷi': 'The Great Section',
#     'Maggasaṃyuttaṃ': '道相應',
#     'Bojjhaṅgasaṃyuttaṃ': '覺支相應',
#     'Satipaṭṭhānasaṃyuttaṃ': '念處相應',
#     'Indriyasaṃyuttaṃ': '根相應',
#     'Sammappadhānasaṃyuttaṃ': '正勤相應',
#     'Balasaṃyuttaṃ': '力相應',
#     'Iddhipādasaṃyuttaṃ': '神足相應',
#     'Anuruddhasaṃyuttaṃ': '阿那律相應',
#     'Jhānasaṃyuttaṃ': '靜慮相應',
#     'Ānāpānasaṃyuttaṃ': '入出息相應',
#     'Sotāpattisaṃyuttaṃ': '入流 (須陀洹)相應',
#     'Saccasaṃyuttaṃ': '諦相應',
  'Aṅguttaranikāya': 'Further-factored Discourses',
    'Ekakanipātapāḷi': 'Book of the Ones',
#     'Rūpādivaggo': '色等品',
#     'Nīvaraṇappahānavaggo': '斷蓋品',
#     'Akammaniyavaggo': '無堪忍品',
#     'Adantavaggo': '無調品',
#     'Paṇihitaacchavaggo': '向與隱覆品',
#     'Accharāsaṅghātavaggo': '彈指品',
#     'Vīriyārambhādivaggo': '發精進等品',
#     'Kalyāṇamittādivaggo': '善友等品',
#     'Pamādādivaggo': '放逸等品',
#     'Dutiyapamādādivaggo': '',
#     'Adhammavaggo': '非法等品',
#     'Anāpattivaggo': '無范等品',
#     'Ekapuggalavaggo': '一人品',
#     'Etadaggavaggo': '是第一品',
#     'Aṭṭhānapāḷi': '無有是處品',
#     'Ekadhammapāḷi': '一法品',
#     'Pasādakaradhammavaggo': '種子品',
#     'Aparaaccharāsaṅghātavaggo': '末伽梨品',
#     'Kāyagatāsativaggo': '不放逸品',
#     'Amatavaggo': '靜慮品',
    'Dukanipātapāḷi': 'Book of the Twos',
#     'Kammakaraṇavaggo': '科刑罰品',
#     'Adhikaraṇavaggo': '靜論品',
#     'Bālavaggo': '愚人品',
#     'Samacittavaggo': '等心品',
#     'Parisavaggo': '會眾品',
#     'Puggalavaggo': '人品',
#     'Sukhavaggo': '樂品',
#     'Sanimittavaggo': '有品',
#     'Dhammavaggo': '法品',
#     'Bālavaggo': '愚者品',
#     'Āsāduppajahavaggo': '希望品',
#     'Āyācanavaggo': '希求品',
#     'Dānavaggo': '施品',
#     'Santhāravaggo': '覆護品',
#     'Samāpattivaggo': '入定品',
#     'Kodhapeyyālaṃ': '忿品',
#     'Akusalapeyyālaṃ': '(律廣說)品',
#     'Vinayapeyyālaṃ': '',
#     'Rāgapeyyālaṃ': '',
    'Tikanipātapāḷi': 'Book of the Threes',
#     'Bālavaggo': '愚人品',
#     'Rathakāravaggo': '車匠品',
#     'Puggalavaggo': '補特羅品',
#     'Devadūtavaggo': '天使品',
#     'Cūḷavaggo': '小品',
#     'Brāhmaṇavaggo': '婆羅門品',
#     'Mahāvaggo': '大品',
#     'Ānandavaggo': '阿難品',
#     'Samaṇavaggo': '沙門品',
#     'Loṇakapallavaggo': '掬鹽品',
#     'Sambodhavaggo': '等覺品',
#     'Āpāyikavaggo': '惡趣品',
#     'Kusināravaggo': '古西那拉品',
#     'Yodhājīvavaggo': '戰士品',
#     'Maṅgalavaggo': '吉祥品',
#     'Acelakavaggo': '裸形品',
#     'Kammapathapeyyālaṃ': '',
#     'Rāgapeyyālaṃ': '',
    'Catukkanipātapāḷi': 'Book of the Fours',
    'Pañcakanipātapāḷi': 'Book of the Fives',
    'Chakkanipātapāḷi': 'Book of the Sixes',
    'Sattakanipātapāḷi': 'Book of the Sevens',
    'Aṭṭhakādinipātapāḷi': 'Book of the Eights',
    'Navakanipātapāḷi': 'Book of the Nines',
    'Dasakanipātapāḷi': 'Book of the Tens',
    'Ekādasakanipātapāḷi': 'Book of the Elevens',
#     'Nissayavaggo': '依止品',
#     'Anussativaggo': '憶念品',
#     'Sāmaññavaggo': '沙門品',
#     'Rāgapeyyālaṃ': '貪品',
  'Khuddakanikāya': 'Collection of Short Discourses',
#  'Khuddakanikāya': 'Division of Short Books',
    'Khuddakapāṭhapāḷi': 'The Short Passages',
      'Saraṇattayaṃ': 'Saranagamana — Going for Refuge',
      'Dasasikkhāpadaṃ': 'The Ten Training Rules',
      'Dvattiṃsākāro': 'The 32 Parts',
      'Kumārapañhā': "Samanera Pañha — The Novice's Questions",
      'Maṅgalasuttaṃ': 'Protection',
      'Ratanasuttaṃ': 'Treasures',
      'Tirokuṭṭasuttaṃ': 'Tirokudda Kanda — Hungry Shades Outside the Walls',
      'Nidhikaṇḍasuttaṃ': 'The Reserve Fund',
      'Mettasuttaṃ': 'Karaniya Metta Sutta — Good Will',
    'Dhammapadapāḷi': 'The Path of Dhamma',
      'Yamakavaggo': 'Pairs',
      'Appamādavaggo': 'Heedfulness',
      'Cittavaggo': 'The Mind',
      'Pupphavaggo': 'Blossoms',
      'Bālavaggo': 'Fools',
      'Paṇḍitavaggo': 'The Wise',
      'Arahantavaggo': 'Arahants',
      'Sahassavaggo': 'Thousands',
      'Pāpavaggo': 'Evil',
      'Daṇḍavaggo': 'The Rod',
      'Jarāvaggo': 'Aging',
      'Attavaggo': 'Self',
      'Lokavaggo': 'Worlds',
      'Buddhavaggo': 'Awakened',
      'Sukhavaggo': 'Happy',
      'Piyavaggo': 'Dear Ones',
      'Kodhavaggo': 'Anger',
      'Malavaggo': 'Impurities',
      'Dhammaṭṭhavaggo': 'The Judge',
      'Maggavaggo': 'The Path',
      'Pakiṇṇakavaggo': 'Miscellany',
      'Nirayavaggo': 'Hell',
      'Nāgavaggo': 'Elephants',
      'Taṇhāvaggo': 'Craving',
      'Bhikkhuvaggo': 'Monks',
      'Brāhmaṇavaggo': 'Brahmans',
    'Udānapāḷi': 'Exclamations',
    'Itivuttakapāḷi': 'The Thus-saids',
    'Suttanipātapāḷi': 'The Discourses Collection',
      'Uragavaggo': 'The Snake Chapter',
      'Cūḷavaggo': 'The Lesser Chapter',
      'Mahāvaggo': 'The Great Chapter',
      'Aṭṭhakavaggo': 'The Octet Chapter',
      'Pārāyanavaggo': 'The Chapter on the Way to the Far Shore',
    'Vimānavatthupāḷi': 'Stories of the Celestial Mansions',
    'Petavatthupāḷi': 'Stories of the Hungry Ghosts',
    'Theragāthāpāḷi': 'Verses of the Elder Monks',
    'Therīgāthāpāḷi': 'Verses of the Elder Nuns',
    'Apadānapāḷi': 'Stories',
    'Buddhavaṃsapāḷi': 'History of the Buddhas',
    'Cariyāpiṭakapāḷi': 'Basket of Conduct',
    'Jātakapāḷi': 'Birth Stories',
#   'Mahāniddesapāḷi': '大義釋',
#   'Cūḷaniddesapāḷi': '小義釋',
    'Paṭisambhidāmaggapāḷi': 'Path of Discrimination',
#   'Nettippakaraṇapāḷi': '導論',
    'Milindapañhapāḷi': 'Questions of Milinda',
#   'Peṭakopadesapāḷi': '藏釋 (三藏知津)',
#'Abhidhammapiṭaka': '',
  'Dhammasaṅgaṇīpāḷi': 'Enumeration of Phenomena',
  'Vibhaṅgapāḷi': 'The Book of Analysis',
# 'Vibhaṅgapāḷi': 'The Book of Treatises',
  'Dhātukathāpāḷi': 'Discourse on Elements',
# 'Dhātukathāpāḷi': 'Discussion with Reference to the Elements',
  'Puggalapaññattipāḷi': 'A Designation of Human Types',
# 'Puggalapaññattipāḷi': 'Description of Individuals',
  'Kathāvatthupāḷi': 'Points of Controversy',
  'Yamakapāḷi': 'The Book of Pairs',
  'Paṭṭhānapāḷi': 'The Book of Relations',
'Aṭṭhakathā': 'Commentaries',
'Tīkā': 'Sub-commentaries',
  'Abhidhammatthasaṅgaho': 'A Comprehensive Manual of Abhidhamma',
  'Visuddhimagga': 'The Path of Purification',
      'Sīlaniddeso': 'DESCRIPTION OF VIRTUE',
      'Dhutaṅganiddeso': 'THE ASCETIC PRACTICES',
      'Kammaṭṭhānaggahaṇaniddeso': 'TAKING A MEDITATION SUBJECT',
      'Pathavīkasiṇaniddeso': 'THE EARTH KASIṆA',
      'Sesakasiṇaniddeso': 'THE REMAINING KASIṆAS',
      'Asubhakammaṭṭhānaniddeso': 'FOULNESS AS A MEDITATION SUBJECT',
      'Chaanussatiniddeso': 'SIX RECOLLECTIONS',
      'Anussatikammaṭṭhānaniddeso': 'OTHER RECOLLECTIONS AS MEDITATION SUBJECTS',
      'Brahmavihāraniddeso': 'THE DIVINE ABIDINGS',
      'Āruppaniddeso': 'THE IMMATERIAL STATES',
      'Samādhiniddeso': 'CONCENTRATION—CONCLUSION: NUTRIMENT AND THE ELEMENTS',
      'Iddhividhaniddeso': 'THE SUPERNORMAL POWERS',
      'Abhiññāniddeso': 'OTHER DIRECT-KNOWLEDGES',
      'Khandhaniddeso': 'THE AGGREGATES',
      'Āyatanadhātuniddeso': 'THE BASES AND ELEMENTS',
      'Indriyasaccaniddeso': 'THE FACULTIES AND TRUTHS',
      'Paññābhūminiddeso': 'THE SOIL OF UNDERSTANDING—CONCLUSION: DEPENDENT ORIGINATION',
      'Diṭṭhivisuddhiniddeso': 'PURIFICATION OF VIEW',
      'Kaṅkhāvitaraṇavisuddhiniddeso': 'PURIFICATION BY OVERCOMING DOUBT',
      'Maggāmaggañāṇadassanavisuddhiniddeso': 'PURIFICATION BY KNOWLEDGE AND VISION OF WHAT IS THE PATH AND WHAT IS NOT THE PATH',
      'Paṭipadāñāṇadassanavisuddhiniddeso': 'PURIFICATION BY KNOWLEDGE AND VISION OF THE WAY',
      'Ñāṇadassanavisuddhiniddeso': 'PURIFICATION BY KNOWLEDGE AND VISION',
      'Paññābhāvanānisaṃsaniddeso': 'THE BENEFITS IN DEVELOPING UNDERSTANDING',
' ': ' '
}
